## tdesktop-6.2.4-full.tar.gz

=== CMakeLists.txt ===
# This file is part of Telegram Desktop,
# the official desktop application for the Telegram messaging service.
#
# For license and copyright information please follow this link:
# https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL

cmake_minimum_required(VERSION 3.25...3.31)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

include(cmake/validate_special_target.cmake)
include(cmake/version.cmake)
desktop_app_parse_version(Telegram/build/version)

project(Telegram
    LANGUAGES C CXX
    VERSION ${desktop_app_version_cmake}
    DESCRIPTION "Official Telegram Desktop messenger"
    HOMEPAGE_URL "https://desktop.telegram.org"
)

if (APPLE)
    enable_language(OBJC OBJCXX)
endif()

set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT Telegram)

get_filename_component(third_party_loc "Telegram/ThirdParty" REALPATH)
get_filename_component(submodules_loc "Telegram" REALPATH)
get_filename_component(cmake_helpers_loc "cmake" REALPATH)

if (NOT DESKTOP_APP_USE_PACKAGED AND WIN32)
    set(Python3_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/../ThirdParty/python/Scripts/python)
endif()

include(cmake/variables.cmake)
include(cmake/nice_target_sources.cmake)
include(cmake/target_compile_options_if_exists.cmake)
include(cmake/target_link_frameworks.cmake)
include(cmake/target_link_options_if_exists.cmake)
include(cmake/init_target.cmake)
include(cmake/generate_target.cmake)
include(cmake/nuget.cmake)
include(cmake/validate_d3d_compiler.cmake)
include(cmake/target_prepare_qrc.cmake)

include(cmake/options.cmake)
include(cmake/external/qt/package.cmake)

set(desktop_app_skip_libs
    glibmm
    variant
)

add_subdirectory(cmake)
add_subdirectory(Telegram)

=== Telegram/lib_crl/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_crl OBJECT)
add_library(desktop-app::lib_crl ALIAS lib_crl)
init_target(lib_crl)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_crl ${src_loc}
PRIVATE
    crl/common/crl_common_config.h
    crl/common/crl_common_fp_exceptions.cpp
    crl/common/crl_common_guards.h
    crl/common/crl_common_list.cpp
    crl/common/crl_common_list.h
    crl/common/crl_common_object_async.h
    crl/common/crl_common_on_main.cpp
    crl/common/crl_common_on_main.h
    crl/common/crl_common_on_main_guarded.h
    crl/common/crl_common_queue.cpp
    crl/common/crl_common_queue.h
    crl/common/crl_common_semaphore.h
    crl/common/crl_common_sync.h
    crl/common/crl_common_utils.h
    crl/dispatch/crl_dispatch_async.cpp
    crl/dispatch/crl_dispatch_async.h
    crl/dispatch/crl_dispatch_on_main.h
    crl/dispatch/crl_dispatch_queue.cpp
    crl/dispatch/crl_dispatch_queue.h
    crl/dispatch/crl_dispatch_semaphore.cpp
    crl/dispatch/crl_dispatch_semaphore.h
    crl/mac/crl_mac_time.cpp
    crl/linux/crl_linux_time.cpp
    crl/qt/crl_qt_async.h
    crl/qt/crl_qt_guards.h
    crl/winapi/crl_winapi_async.cpp
    crl/winapi/crl_winapi_async.h
    crl/winapi/crl_winapi_dll.h
    crl/winapi/crl_winapi_fp_exceptions.cpp
    crl/winapi/crl_winapi_list.cpp
    crl/winapi/crl_winapi_list.h
    crl/winapi/crl_winapi_semaphore.cpp
    crl/winapi/crl_winapi_semaphore.h
    crl/winapi/crl_winapi_time.cpp
    crl/winapi/crl_winapi_windows_h.h
    crl/crl.h
    crl/crl_async.h
    crl/crl_fp_exceptions.h
    crl/crl_object_on_queue.h
    crl/crl_object_on_thread.cpp
    crl/crl_object_on_thread.h
    crl/crl_on_main.h
    crl/crl_queue.h
    crl/crl_semaphore.h
    crl/crl_time.cpp
    crl/crl_time.h
)

target_include_directories(lib_crl
PUBLIC
    ${src_loc}
)

if (TARGET desktop-app::external_dispatch)
    target_link_libraries(lib_crl
    PUBLIC
        desktop-app::external_dispatch
    )
endif()

if (build_macstore OR TARGET desktop-app::external_dispatch)
    target_compile_definitions(lib_crl
    PUBLIC
        CRL_FORCE_COMMON_QUEUE
    )
endif()

if (TARGET desktop-app::external_qt)
    target_link_libraries(lib_crl
    PUBLIC
        desktop-app::external_qt
    )
endif()

=== Telegram/lib_lottie/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_lottie OBJECT)
add_library(desktop-app::lib_lottie ALIAS lib_lottie)
init_target(lib_lottie)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_lottie ${src_loc}
PRIVATE
    lottie/details/lottie_frame_provider.h
    lottie/details/lottie_frame_provider_direct.cpp
    lottie/details/lottie_frame_provider_direct.h
    lottie/details/lottie_frame_provider_shared.cpp
    lottie/details/lottie_frame_provider_shared.h
    lottie/details/lottie_frame_renderer.cpp
    lottie/details/lottie_frame_renderer.h
    lottie/lottie_animation.cpp
    lottie/lottie_animation.h
    lottie/lottie_common.cpp
    lottie/lottie_common.h
    lottie/lottie_frame_generator.cpp
    lottie/lottie_frame_generator.h
    lottie/lottie_multi_player.cpp
    lottie/lottie_multi_player.h
    lottie/lottie_player.h
    lottie/lottie_single_player.cpp
    lottie/lottie_single_player.h
    lottie/lottie_icon.cpp
    lottie/lottie_icon.h
)

if (DESKTOP_APP_LOTTIE_USE_CACHE)
    nice_target_sources(lib_lottie ${src_loc}
    PRIVATE
        lottie/details/lottie_cache.cpp
        lottie/details/lottie_cache.h
        lottie/details/lottie_cache_frame_storage.cpp
        lottie/details/lottie_cache_frame_storage.h
        lottie/details/lottie_frame_provider_cached.cpp
        lottie/details/lottie_frame_provider_cached.h
        lottie/details/lottie_frame_provider_cached_multi.cpp
        lottie/details/lottie_frame_provider_cached_multi.h
    )
    target_compile_definitions(lib_lottie PRIVATE LOTTIE_USE_CACHE)
    target_link_libraries(lib_lottie
    PRIVATE
        desktop-app::lib_ffmpeg
        desktop-app::external_lz4
    )
endif()

if (DESKTOP_APP_LOTTIE_DISABLE_RECOLORING)
    target_compile_definitions(lib_lottie PRIVATE LOTTIE_DISABLE_RECOLORING)
endif()

target_include_directories(lib_lottie
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_lottie
PUBLIC
    desktop-app::lib_ui
PRIVATE
    desktop-app::external_rlottie
)

=== Telegram/lib_qr/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_qr OBJECT)
add_library(desktop-app::lib_qr ALIAS lib_qr)
init_target(lib_qr)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_qr ${src_loc}
PRIVATE
    qr/qr_generate.cpp
    qr/qr_generate.h
)

target_include_directories(lib_qr
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_qr
PUBLIC
    desktop-app::lib_base
    desktop-app::external_qr_code_generator
)

=== Telegram/lib_webview/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_webview STATIC)
add_library(desktop-app::lib_webview ALIAS lib_webview)
init_target(lib_webview)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_webview ${src_loc}
PRIVATE
    webview/webview_common.h
    webview/webview_data_stream.h
    webview/webview_data_stream_memory.cpp
    webview/webview_data_stream_memory.h
    webview/webview_dialog.cpp
    webview/webview_dialog.h
    webview/webview_embed.cpp
    webview/webview_embed.h
    webview/webview_interface.h

    webview/platform/mac/webview_mac.h
    webview/platform/mac/webview_mac.mm

    webview/platform/linux/webview_linux.h
    webview/platform/linux/webview_linux.cpp
    webview/platform/linux/webview_linux_compositor.cpp
    webview/platform/linux/webview_linux_compositor.h
    webview/platform/linux/webview_linux_http_server.cpp
    webview/platform/linux/webview_linux_http_server.h
    webview/platform/linux/webview_linux_webkitgtk_library.cpp
    webview/platform/linux/webview_linux_webkitgtk_library.h
    webview/platform/linux/webview_linux_webkitgtk.cpp
    webview/platform/linux/webview_linux_webkitgtk.h

    webview/platform/win/webview_win.cpp
    webview/platform/win/webview_win.h
    webview/platform/win/webview_windows_data_stream.cpp
    webview/platform/win/webview_windows_data_stream.h
    webview/platform/win/webview_windows_edge_chromium.cpp
    webview/platform/win/webview_windows_edge_chromium.h
    webview/platform/win/webview_windows_edge_html.cpp
    webview/platform/win/webview_windows_edge_html.h
)

target_include_directories(lib_webview
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_webview
PUBLIC
    desktop-app::lib_ui
    desktop-app::lib_base
)

if (WIN32)
    nuget_add_webview(lib_webview)
elseif (LINUX)
    include(${cmake_helpers_loc}/external/glib/generate_dbus.cmake)
    generate_dbus(lib_webview org.desktop_app.GtkIntegration.Webview. Webview ${src_loc}/webview/platform/linux/webview_linux_interface.xml)

    target_compile_definitions(lib_webview
    PRIVATE
        G_LOG_DOMAIN="WebView"
    )
endif()

=== cmake/external/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

macro(add_checked_subdirectory name)
    if (NOT DEFINED desktop_app_skip_libs
        OR NOT ${name} IN_LIST desktop_app_skip_libs)
        add_subdirectory(${name})
    endif()
endmacro()

add_checked_subdirectory(ada)
add_checked_subdirectory(angle)
add_checked_subdirectory(auto_updates)
add_checked_subdirectory(boost)
if (add_cld3_library)
    add_checked_subdirectory(cld3)
endif()
add_checked_subdirectory(crash_reports)
if (LINUX)
    add_checked_subdirectory(dispatch)
endif()
add_checked_subdirectory(expected)
add_checked_subdirectory(ffmpeg)
if (LINUX)
    add_checked_subdirectory(glib)
    add_checked_subdirectory(glibmm)
endif()
add_checked_subdirectory(gsl)
if (add_hunspell_library)
	add_checked_subdirectory(hunspell)
endif()
add_checked_subdirectory(iconv)
add_checked_subdirectory(jpeg)
add_checked_subdirectory(kcoreaddons)
add_checked_subdirectory(lz4)
add_checked_subdirectory(minizip)
add_checked_subdirectory(openal)
add_checked_subdirectory(openh264)
add_checked_subdirectory(openssl)
add_checked_subdirectory(opus)
add_checked_subdirectory(qt)
add_checked_subdirectory(qr_code_generator)
add_checked_subdirectory(ranges)
add_checked_subdirectory(rlottie)
add_checked_subdirectory(rnnoise)
add_checked_subdirectory(tde2e)
add_checked_subdirectory(ton)
add_checked_subdirectory(variant)
add_checked_subdirectory(vpx)
add_checked_subdirectory(webrtc)
if (LINUX AND NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
    add_checked_subdirectory(xcb)
endif()
add_checked_subdirectory(xxhash)
add_checked_subdirectory(zlib)

=== cmake/win_directx_helper/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(win_directx_helper STATIC)
init_target(win_directx_helper "(external)")
add_library(desktop-app::win_directx_helper ALIAS win_directx_helper)

nice_target_sources(win_directx_helper ${CMAKE_CURRENT_SOURCE_DIR}
PRIVATE
    win_directx_helper.cpp
)

validate_d3d_compiler(win_directx_helper)

target_link_libraries(win_directx_helper
PUBLIC
    desktop-app::external_openssl
)

if (NOT DESKTOP_APP_SPECIAL_TARGET STREQUAL "")
    target_compile_definitions(win_directx_helper
    PRIVATE
        WIN_DIRECTX_HELPER_SPECIAL_TARGET=${DESKTOP_APP_SPECIAL_TARGET}
    )
endif()

=== Telegram/ThirdParty/fcitx5-qt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(fcitx5-qt VERSION 5.1.6)
set(FCITX5_QT_VERSION ${PROJECT_VERSION})

set(REQUIRED_QT4_VERSION 4.8.0)
set(REQUIRED_QT5_VERSION 5.5.0)
set(REQUIRED_QT6_VERSION 6.0.0)

find_package(ECM 1.4.0 REQUIRED)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(ENABLE_QT4 "Enable Qt 4" Off)
option(ENABLE_QT5 "Enable Qt 5" On)
option(ENABLE_QT6 "Enable Qt 6" On)
option(ENABLE_X11 "Enable X11 support" On)
option(BUILD_ONLY_PLUGIN "Build only plugin" Off)
option(BUILD_STATIC_PLUGIN "Build plugin as static" Off)
option(WITH_FCITX_PLUGIN_NAME "Enable plugin name with fcitx" On)
option(ENABLE_QT6_WAYLAND_WORKAROUND "Enable Qt6 Wayland workaround" On)

if (BUILD_ONLY_PLUGIN)
  set(LIBRARY_TYPE OBJECT)
else()
  set(LIBRARY_TYPE SHARED)
  add_definitions(-DFCITX_GETTEXT_DOMAIN=\"fcitx5-qt\")
  if (BUILD_STATIC_PLUGIN)
    message(FATAL_ERROR "BUILD_STATIC_PLUGIN requires BUILD_ONLY_PLUGIN")
  endif()
endif()

if (BUILD_ONLY_PLUGIN AND BUILD_STATIC_PLUGIN)
  set(PLUGIN_LIBRARY_TYPE STATIC)
else()
  set(PLUGIN_LIBRARY_TYPE MODULE)
endif()

add_definitions(-DFCITX5_QT_VERSION=\"${FCITX5_QT_VERSION}\")

include(GNUInstallDirs)
include(FeatureSummary)
include(GenerateExportHeader)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMUninstallTarget)

if (ENABLE_X11)
    find_package(XCB REQUIRED COMPONENTS XCB)
endif()
find_package(XKBCommon 0.5.0 REQUIRED COMPONENTS XKBCommon)
if (NOT BUILD_ONLY_PLUGIN)
find_package(Fcitx5Utils 5.0.16 REQUIRED)
endif()

if (ENABLE_X11)
find_package(X11 REQUIRED)

add_library(X11Import UNKNOWN IMPORTED)
set_target_properties(X11Import PROPERTIES
    IMPORTED_LOCATION "${X11_X11_LIB}"
    INTERFACE_INCLUDE_DIRECTORIES "${X11_X11_INCLUDE_PATH}")
endif()

if (BUILD_ONLY_PLUGIN)
# Dup a little bit option here.
include(CompilerSettings)
else()
include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
find_package(Gettext REQUIRED)
endif()

set(Fcitx5Qt6_INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5Qt6)
set(Fcitx5Qt5_INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5Qt5)
set(Fcitx5Qt4_INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5Qt4)

if(ENABLE_QT4)
  add_subdirectory(qt4)
endif()

if(ENABLE_QT5)
  add_subdirectory(qt5)
endif()

if(ENABLE_QT6)
  add_subdirectory(qt6)
endif()

if(NOT BUILD_ONLY_PLUGIN)
add_subdirectory(po)
endif()

enable_testing()
add_subdirectory(test)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== Telegram/ThirdParty/rlottie/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.3 )

#declare project
project( rlottie VERSION 0.0.1 LANGUAGES C CXX ASM)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE MinSizeRel)
endif()

if (NOT DEFINED BUILD_SHARED_LIBS)
    # Keep the previous behavior of the build system, consistent with Meson.
    set(BUILD_SHARED_LIBS ON)
endif()

#declare target
add_library( rlottie )
set_target_properties( rlottie PROPERTIES DEFINE_SYMBOL LOT_BUILD )

#declare version of the target
set(player_version_major 0)
set(player_version_minor 0)
set(player_version_patch 1)
set(player_version ${player_version_major}.${player_version_minor}.${player_version_patch} )
set_target_properties(rlottie PROPERTIES
                        VERSION    ${player_version}
                        SOVERSION  ${player_version_major}
                      )

#declare alias so that library can be used inside the build tree, e.g. when testing
add_library(rlottie::rlottie ALIAS rlottie)

option(LOTTIE_MODULE "Enable LOTTIE MODULE SUPPORT" ON)
option(LOTTIE_THREAD "Enable LOTTIE THREAD SUPPORT" ON)
option(LOTTIE_CACHE "Enable LOTTIE CACHE SUPPORT" ON)
option(LOTTIE_TEST "Build LOTTIE AUTOTESTS" OFF)

CONFIGURE_FILE(${CMAKE_CURRENT_LIST_DIR}/cmake/config.h.in config.h)

target_include_directories(rlottie
    PRIVATE
        "${CMAKE_CURRENT_BINARY_DIR}"
    )

#declare target compilation options
target_compile_options(rlottie
                    PUBLIC
                    PRIVATE
                        -std=c++14
                        -fno-exceptions
                        -fno-unwind-tables
                        -fno-asynchronous-unwind-tables
                        -fno-rtti
                        -Wall
                        -Werror
                        -Wextra
                        -Wnon-virtual-dtor
                        -Woverloaded-virtual
                        -Wno-unused-parameter
                        -fvisibility=hidden
                    )

#declare dependancy
set( CMAKE_THREAD_PREFER_PTHREAD TRUE )
find_package( Threads )

target_link_libraries(rlottie
                    PUBLIC
                        "${CMAKE_THREAD_LIBS_INIT}"
                     )

if (LOTTIE_MODULE)
    # for dlopen, dlsym and dlclose dependancy
    target_link_libraries(rlottie PRIVATE ${CMAKE_DL_LIBS})
endif()

if(APPLE)
    target_link_libraries(rlottie
                        PUBLIC
                             "-Wl, -undefined error"
                          )
else()
    target_link_libraries(rlottie
                        PUBLIC
                             "-Wl,--no-undefined"
                          )
endif()


if (NOT LIB_INSTALL_DIR)
    set (LIB_INSTALL_DIR "/usr/lib")
endif (NOT LIB_INSTALL_DIR)

#declare source and include files
add_subdirectory(inc)
add_subdirectory(src)
add_subdirectory(example)

if (LOTTIE_TEST)
    enable_testing()
    add_subdirectory(test)
endif()

SET(PREFIX ${CMAKE_INSTALL_PREFIX})
SET(EXEC_DIR ${PREFIX})
SET(LIBDIR ${LIB_INSTALL_DIR})
SET(INCDIR ${PREFIX}/include)

CONFIGURE_FILE(${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)


#install header
install(FILES
        inc/rlottie.h
        inc/rlottie_capi.h
        inc/rlottiecommon.h
        DESTINATION include)

#install lib
install( TARGETS rlottie EXPORT rlottie-targets
         LIBRARY     DESTINATION    ${LIB_INSTALL_DIR}
         ARCHIVE     DESTINATION    ${LIB_INSTALL_DIR}
         INCLUDES    DESTINATION    include
       )

#install config file.

install( EXPORT rlottie-targets
         FILE          rlottieTargets.cmake
         NAMESPACE     rlottie::
         DESTINATION   ${LIB_INSTALL_DIR}/cmake/rlottie
       )


#Create a ConfigVersion.cmake file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/rlottieConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfig.cmake
    INSTALL_DESTINATION ${LIB_INSTALL_DIR}/cmake/rlottie
)

#Install the config, configversion and custom find modules
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/rlottieConfigVersion.cmake
    DESTINATION ${LIB_INSTALL_DIR}/cmake/rlottie
)


export(EXPORT rlottie-targets FILE ${CMAKE_CURRENT_BINARY_DIR}/rlottieTargets.cmake NAMESPACE rlottie::)

#Register package in user's package registry
export(PACKAGE rlottie)

=== Telegram/ThirdParty/rlottie/meson_options.txt ===
option('thread',
   type: 'boolean',
   value: true,
   description: 'Enable threading in rlottie')

option('cache',
   type: 'boolean',
   value: true,
   description: 'Enable cache support in rlottie')

option('module',
   type: 'boolean',
   value: true,
   description: 'Enable module support in rlottie')

option('log',
   type: 'boolean',
   value: false,
   description: 'Enable logging in rlottie')

option('dumptree',
   type: 'boolean',
   value: false,
   description: 'Enable logging the rlottie tree in rlottie')

option('test',
   type: 'boolean',
   value: false,
   description: 'Enable building unit tests')

option('example',
   type: 'boolean',
   value: true,
   description: 'Enable building examples')

option('cmake',
  type: 'boolean',
  value: false,
  description: 'Enable Generating  CMake config files')

=== Telegram/ThirdParty/xdg-desktop-portal/meson_options.txt ===
option('dbus-service-dir',
       type: 'string',
       value: '',
       description: 'directory for dbus service files (default: PREFIX/share/dbus-1/services)')
option('flatpak-interfaces',
       type: 'feature',
       value: 'auto',
       description: 'Build flatpak interfaces')
option('flatpak-interfaces-dir',
       type: 'string',
       value: '',
       description: 'directory for Flatpak interface files (default: PREFIX/share/dbus-1/interfaces)')
option('systemd-user-unit-dir',
       type: 'string',
       value: '',
       description: 'directory for systemd user service files (default: PREFIX/lib/systemd/user)')
option('libportal',
       type: 'feature',
       value: 'auto',
       description: 'Enable libportal support. Needed for tests')
option('geoclue',
       type: 'feature',
       value: 'auto',
       description: 'Enable Geoclue support. Needed for location portal')
option('systemd',
       type: 'feature',
       value: 'auto',
       description: 'Enable systemd support')
option('docbook-docs',
       type: 'feature',
       value: 'auto',
       description: 'Build documentation (requires xmlto)')
option('xmlto-flags',
       type: 'array',
       value: [],
       description: 'Define/override "xmlto" options, like "--skip-validation"')
option('datarootdir',
        type: 'string',
        value: '',
        description: 'Define the datarootdir for the pkgconf file')
option('installed-tests',
        type: 'boolean',
        value: false,
        description: 'Enable installation of some test cases')
option('pytest',
        type: 'feature',
        value: 'auto',
        description: 'Enable the pytest-based test suite')
option('man-pages',
       type: 'feature',
       value: 'auto',
       description: 'Build man pages (requires rst2man)')
option('sandboxed-image-validation',
       type: 'boolean',
       value: true,
       description: 'Use Bubblewrap to sandbox image validation. Disabling this option may lead to security vulnerabilities.')

=== cmake/external/dispatch/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

set(dispatch_loc ${third_party_loc}/dispatch)
set(dispatch_prefix ${CMAKE_CURRENT_BINARY_DIR}/dispatch-prefix)
set(dispatch_binary_dir ${dispatch_prefix}/src/dispatch-build)

if (DESKTOP_APP_USE_PACKAGED)
    find_library(DESKTOP_APP_DISPATCH_LIBRARIES dispatch)
    find_path(DESKTOP_APP_DISPATCH_INCLUDE_DIRS dispatch/dispatch.h)
endif()

if (NOT DESKTOP_APP_DISPATCH_LIBRARIES OR NOT DESKTOP_APP_DISPATCH_INCLUDE_DIRS)
    execute_process(
        COMMAND ${CMAKE_COMMAND} ${dispatch_loc}
            -B ${dispatch_binary_dir}
            -GNinja
            -DCMAKE_BUILD_TYPE=Release
            -DCMAKE_C_COMPILER=clang
            -DCMAKE_CXX_COMPILER=clang++
            -DCMAKE_C_FLAGS=-g
            -DCMAKE_CXX_FLAGS=-g
            -DBUILD_SHARED_LIBS=OFF
            -DBUILD_TESTING=OFF
    )

    execute_process(
        COMMAND ${CMAKE_COMMAND} --build ${dispatch_binary_dir} --parallel
    )

    if (NOT EXISTS ${dispatch_binary_dir}/src/libdispatch.a)
        if (DESKTOP_APP_SPECIAL_TARGET)
            message(FATAL_ERROR "Dispatch build failed")
        else()
            return()
        endif()
    endif()
endif()

add_library(external_dispatch INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_dispatch ALIAS external_dispatch)

if (DESKTOP_APP_USE_PACKAGED AND DESKTOP_APP_DISPATCH_LIBRARIES AND DESKTOP_APP_DISPATCH_INCLUDE_DIRS)
    target_include_directories(external_dispatch SYSTEM INTERFACE ${DESKTOP_APP_DISPATCH_INCLUDE_DIRS})
    target_link_libraries(external_dispatch INTERFACE ${DESKTOP_APP_DISPATCH_LIBRARIES})
    return()
endif()

add_library(external_dispatch_bundled STATIC IMPORTED)

set_target_properties(external_dispatch_bundled PROPERTIES
    IMPORTED_LOCATION "${dispatch_binary_dir}/src/libdispatch.a"
)

target_include_directories(external_dispatch_bundled SYSTEM
INTERFACE
    ${dispatch_loc}
)

target_link_libraries(external_dispatch_bundled
INTERFACE
    ${dispatch_binary_dir}/src/BlocksRuntime/libBlocksRuntime.a
)

target_link_libraries(external_dispatch
INTERFACE
    external_dispatch_bundled
)

=== Telegram/ThirdParty/hime/distro/debian/changelog ===
hime (9-9) experimental; urgency=low

  * New snapshot.

 -- The HIME Project <http://hime.luna.com.tw>  Tue, 13 Dec 2011 14:15:16 +0800

=== Telegram/ThirdParty/hime/distro/archlinux/PKGBUILD ===
# Contributor: HIME team
_pkgname=hime
pkgname=hime-git
pkgver=1101.0bb91a0
pkgrel=1
pkgdesc="A GTK2+/GTK3+ based universal input method platform"
arch=('x86_64')
url="http://hime-ime.github.io/"
license=('LGPL2' 'FDL' 'GPL2')
depends=('gtk2' 'libxtst')
makedepends=('git' 'gettext')
# uncomment and edit next line to enable those plugins
# makedepends+=('gtk3' 'qt5-base' 'anthy' 'libchewing')
optdepends=('gtk3: enable gtk3 im module'
            'qt5-base: enable qt5 im module'
            'anthy: enable Anthy input method'
            'libchewing: enable Chewing input method')
conflicts=('hime')
provides=('hime')
source=("${_pkgname}::git+https://github.com/hime-ime/hime.git")
sha512sums=('SKIP')

pkgver() {
    cd "${srcdir}/${_pkgname}"
    echo "$(git rev-list --count master).$(git rev-parse --short master)"
}

build() {
    cd "${srcdir}/${_pkgname}"
    ./configure --prefix=/usr --qt5-im-module-path=/usr/lib/qt/plugins/platforminputcontexts/
    make
}

package() {
    cd "${srcdir}/${_pkgname}"
    make DESTDIR="${pkgdir}" install

    install -dm755 "${pkgdir}/usr/share/licenses/${_pkgname}/"
    # install licence files
    install -Dm644 fdl-1.2.txt gpl-2.0.txt lgpl-2.1.txt "${pkgdir}/usr/share/licenses/${_pkgname}/"
}

=== Telegram/ThirdParty/nimf/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with autoreconf

override_dh_autoreconf:
	./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- --with-im-config-data --enable-gtk-doc

override_dh_auto_clean:
	rm -rf $(STAMP_DIR) $(SOURCE_DIR)
	dh_clean

override_dh_clean:
	dh_clean
	rm -rf autom4te.cache
	rm -f aclocal.m4 config.log config.status
	rm -rf debian/tmp
	
override_dh_auto_install:
	dh_auto_install
	# Ensure the correct installation path for GTK 4.0
	mkdir -p debian/tmp/usr/lib/x86_64-linux-gnu/gtk-4.0

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -- -l/usr/lib/nimf

# Add this override to skip tests
override_dh_auto_test:
	echo "Skipping tests"
